#include "string.h"
#include "stdlib.h"

#include "SDL.h"
#include "SDL_ttf.h"

#include "BList.h"
#include "auxiliar.h"

#include "variables.h"
#include "mog2.h"
#include "tiles.h"
#include "object.h"

#include "BWindow.h"
#include "BActiveWindow.h"
#include "BFileListWnd.h"
#include "BActiveWindow.h"
#include "BStringEdDlg.h"
#include "BIntegerEdDlg.h"
#include "BChoiceDlg.h"
#include "BVChoiceDlg.h"
#include "BFileDlg.h"
#include "BMultiListWnd.h"

#include "BPlaneSelectionDlg.h"

#ifdef KITSCHY_DEBUG_MEMORY 
#include "debug_memorymanager.h"
#endif

BPlaneSelectionDlg::BPlaneSelectionDlg(int x,int y,int dx,int dy,int used_object_planes,char *msg,TTF_Font *font) : BActiveWindow(x,y,dx,dy,font)
{
	BButton *b;

	b=new BButton(20,dy-40,80,12,msg,1);
	buttons.Add(b);
	b=new BButton(20,dy-20,80,12,"CANCEL",2);
	buttons.Add(b);

	x_offs=0;
	y_offs=0;

	{
		int i;
		char tmp[80],*tmp2;

		for(i=0;i<used_object_planes;i++) {
			sprintf(tmp,"Plane %i",i);
			tmp2=new char[strlen(tmp)+1];
			strcpy(tmp2,tmp);
			plane_names.Add(tmp2);
		} /* for */ 

		lw=new BMultiListWnd(10,10,100,dy-60,&plane_names,font);
	}

} /* BPlaneSelectionDlg::BPlaneSelectionDlg */ 


BPlaneSelectionDlg::~BPlaneSelectionDlg()
{
	delete lw;
} /* BPlaneSelectionDlg::~BPlaneSelectionDlg */ 


bool BPlaneSelectionDlg::cycle(int stx,int sty)
{
	bool retval;

	retval=BWindow::cycle(stx,sty);

	if (lw!=0) {
		lw->cycle(stx+10,sty+10);
		if (lw->is_dirty()) set_dirty();
	} /* if */ 

	if (((mouse_button&SDL_BUTTON(1) &&
		 !(old_mouse_button&SDL_BUTTON(1))) ||
		 (mouse_button&SDL_BUTTON(3) &&
		 !(old_mouse_button&SDL_BUTTON(3)))) &&
		local_mouse_x>=old_stx && 
		local_mouse_y>=old_sty &&
		local_mouse_x<old_endx &&
		local_mouse_y<old_endy) {

	} /* if */ 

	return retval;
} /* BRMoveDlg::cycle */ 



void BPlaneSelectionDlg::contens_size(int *dx,int *dy)
{
	*dx=old_dx;
	*dy=old_dy;
} /* BRMoveDlg::contens_size */ 


void BPlaneSelectionDlg::draw_contens(SDL_Surface *sfc,int stx,int sty,int dx,int dy)
{
	SDL_Rect r;

	SDL_FillRect(sfc,0,0x0000007f);

	r.x=1-stx;
	r.y=1-sty;
	r.w=dx-2;
	r.h=dy-2;
	SDL_FillRect(sfc,&r,0x000000ff);

	BActiveWindow::draw_contens(sfc,stx,sty,dx,dy);

	lw->draw(sfc,10-stx,10-sty,100,dy-60);

} /* BPlaneSelectionDlg::draw_contens */ 


bool BPlaneSelectionDlg::button_pressed(int ID)
{
	switch(ID) {
	case 1:
		return false;
		break;

	case 2:
		delete lw;
		lw=0;
		return false;
		break;

	default:
		break;
	} /* switch */ 

	return true;
} /* BPlaneSelectionDlg::button_pressed */ 


bool BPlaneSelectionDlg::selected_p(int i)
{
	if (lw!=0) {
		return lw->selected_p(i);
	} /* if */ 

	return false;
} /* BPlaneSelectionDlg::selected_p */ 
